uniform lowp sampler2D u_texture;
uniform mediump vec4 u_color;

varying lowp vec4 v_color;
varying mediump vec2 v_texCoord;
varying lowp float v_fogFactor;

void main()
{
	lowp vec4 texcol2D = texture2D( u_texture, v_texCoord );
	
	// アルファ値が0.0以下であれば描画しない
	if( texcol2D.a <= 0.0 )	discard;
	
	// 2Dテクスチャの色を反映
	// 頂点カラーを反映
	// 現在の描画色にフォグ係数を反映
	// 現在の色に視点からの距離によるフォグの色を反映
	gl_FragColor = ( ( u_color * v_color * texcol2D ) * v_fogFactor );
}
