attribute highp vec4 a_vertex;
attribute lowp vec4 a_color;
attribute mediump vec2 a_texCoord;

uniform highp mat4 u_ModelViewProj;

uniform lowp vec4 u_fogColor;

varying lowp vec4 v_color;
varying mediump vec2 v_texCoord;
varying lowp float v_fogFactor;
varying lowp vec3 v_fogColor;

void main()
{
	// 出力位置を座標変換する
    gl_Position = u_ModelViewProj * a_vertex;
	
	// 頂点カラーをそのまま渡す
	v_color = a_color;
	
	// テクスチャ座標をそのまま渡す
	v_texCoord = a_texCoord;
		
	// フォグ係数を[0,1]で作成
	v_fogFactor = 1.0 - u_fogColor.a;
	
	// フォグ係数とフォグの色から視点からの距離による色を作成
	v_fogColor = u_fogColor.rgb * u_fogColor.a;
}
