attribute highp vec4 a_vertex;
attribute mediump vec3 a_normal;
attribute lowp vec4 a_color;
attribute mediump vec2 a_texCoord;

uniform highp mat4 u_ModelViewProj;

uniform lowp vec3 u_lightAmbient;
uniform lowp vec3 u_lightDiffuse;
uniform highp vec3 u_lightPosition;

uniform lowp vec3 u_materialAmbient;
uniform lowp vec3 u_materialDiffuse;

varying lowp vec4 v_color;
varying mediump vec2 v_texCoord;
varying lowp vec4 v_diffuse;


void main()
{
	gl_Position = u_ModelViewProj * a_vertex;
	
	lowp vec3 N = normalize( a_normal );
		
	//　Ambient Color
	lowp vec3 ambient = u_materialAmbient * u_lightAmbient;
	
	//　Diffuse Color
	lowp float diffuseLight = max(dot(u_lightPosition, N), 0.0);
	mediump vec3 diffuse = u_materialDiffuse * u_lightDiffuse * diffuseLight;
	
	v_color = a_color;
	v_diffuse = vec4( ambient + diffuse, 1.0 );
	v_texCoord = a_texCoord;
}
