uniform lowp sampler2D u_texture;
uniform mediump float u_blurStep;
uniform mediump vec4 u_color;

varying lowp vec4 v_color;
varying mediump vec2 v_texCoord;
//varying lowp vec4 v_diffuse;

void main()
{
//	gl_FragColor = v_color * v_diffuse * texture2D( u_texture, v_texCoord );
	vec4 sampler0, sampler1, sampler2, sampler3;
	
	float step = u_blurStep;
	
	sampler0 = u_color * v_color * texture2D( u_texture, vec2(v_texCoord.x - step, v_texCoord.y - step) );
	sampler1 = u_color * v_color * texture2D( u_texture, vec2(v_texCoord.x + step, v_texCoord.y - step) );
	sampler2 = u_color * v_color * texture2D( u_texture, vec2(v_texCoord.x - step, v_texCoord.y + step) );
	sampler3 = u_color * v_color * texture2D( u_texture, vec2(v_texCoord.x + step, v_texCoord.y + step) );

	gl_FragColor = (sampler0 + sampler1 + sampler2 + sampler3) * 0.25;

//	gl_FragColor = v_color;
}
