attribute highp vec4 a_vertex;
attribute mediump vec3 a_normal;
attribute lowp vec4 a_color;
attribute mediump vec2 a_texCoord;

uniform highp mat4 u_ModelViewProj;
uniform highp vec3 u_eyePosition;

uniform lowp vec3 u_lightAmbient;
uniform lowp vec3 u_lightDiffuse;
uniform lowp vec3 u_lightSpecular;
uniform highp vec3 u_lightPosition;
uniform mediump float u_lightConstantAttenuation;
uniform mediump float u_lightLinearAttenuation;
uniform mediump float u_lightQuadraticAttenuation;

//uniform lowp vec3 u_materialAmbient;
//uniform lowp vec3 u_materialDiffuse;
//uniform lowp vec3 u_materialSpecular;
uniform lowp vec3 u_materialEmission;
uniform mediump float u_materialShininess;

uniform lowp float u_alpha;

varying lowp vec4 v_color;
varying mediump vec2 v_texCoord;
varying lowp vec4 v_diffuse;


uniform highp mat4 u_ModelView;
uniform highp mat4 u_invModelView;
uniform mediump float u_blurStep;




void main()
{

	vec3 N = normalize( a_normal );
	
	vec3 E = normalize( u_eyePosition - a_vertex.xyz );
	
	vec3 L = normalize( u_lightPosition - a_vertex.xyz );
	
	// ハーフベクトル
	vec3 H = normalize( L + E );
	
	gl_Position = u_ModelViewProj * a_vertex;
	
//	v_color = a_color * vec4( u_materialEmission + u_lightAmbient + 
//							  u_materialDiffuse * u_lightDiffuse * max( dot( N, L ), 0.0 ) +
//							  u_materialSpecular * u_lightSpecular * pow(max(dot(N, H), 0.0), u_materialShininess), u_alpha );
	v_color = a_color * vec4( u_materialEmission + u_lightAmbient + 
							  u_lightDiffuse * max( dot( N, L ), 0.0 ) +
							  u_lightSpecular * pow(max(dot(N, H), 0.0), u_materialShininess), u_alpha );
	
	v_texCoord = a_texCoord;
	u_blurStep = u_alpha;

}
