attribute highp vec4 a_vertex;
attribute mediump vec3 a_normal;
attribute lowp vec4 a_color;
attribute mediump vec2 a_texCoord;
attribute mediump vec3 a_tangent;

uniform highp mat4 u_ModelViewProj;
uniform highp vec3 u_eyePosition;

uniform lowp vec3 u_lightAmbient;
uniform lowp vec3 u_lightDiffuse;
uniform lowp vec3 u_lightSpecular;
uniform highp vec3 u_lightPosition;
uniform mediump float u_lightConstantAttenuation;
uniform mediump float u_lightLinearAttenuation;
uniform mediump float u_lightQuadraticAttenuation;

uniform lowp vec3 u_materialAmbient;
uniform lowp vec3 u_materialDiffuse;
uniform lowp vec3 u_materialSpecular;
uniform lowp vec3 u_materialEmission;
uniform mediump float u_materialShininess;

varying lowp vec4 v_color;
varying mediump vec2 v_texCoord;
varying lowp vec4 v_diffuse;
//varying lowp vec4 v_Light;
//varying lowp vec4 v_vcolor;
varying lowp vec3 v_Ambient;
varying lowp vec3 v_Diffuse;
varying lowp vec3 v_Specular;

varying lowp vec3 v_Light;
varying lowp vec3 v_Eye;

//varying highp vec4 v_vertex;
//varying mediump vec3 v_normal;


uniform highp mat4 u_ModelView;
uniform highp mat4 u_invModelView;




void main()
{
#if 0
//	const vec3 RimColor = vec3( 0.5, 0.5, 0.5 );
	
	vec3 N = normalize( a_normal );
	
	vec3 E = normalize( u_eyePosition - a_vertex.xyz );
	
	vec3 L = normalize( -u_lightPosition );
	
	// ハーフベクトル
	vec3 H = normalize( L + E );
	
	// 接線
	vec3 T = a_tangent;
//	vec3 T = normalize(cross(N, vec3(0.0, 1.0, 0.0)));
	
	// 従法線
	vec3 B = cross( N, T );
	
	
	
	vec3 Ambient = u_materialAmbient * u_lightAmbient;
	
//	vec3 Diffuse = u_materialDiffuse * u_lightDiffuse;
	vec3 Diffuse = u_materialDiffuse * u_lightDiffuse * max( dot( N, L ), 0.0 );
	
	vec3 Specular = u_materialSpecular * u_lightSpecular * pow(max(dot(N, H), 0.0), u_materialShininess);
	
//	vec3 Rim = RimColor * pow( 1.0 - dot( N, E ), 2.0 );
	
	gl_Position = u_ModelViewProj * a_vertex;
	
	//	v_color = vec4( u_materialEmission + Ambient + Diffuse + Specular/* + Rim*/, 1.0 );
//	v_color = vec4( u_materialEmission + Ambient + Specular/* + Rim*/, 1.0 );
//	v_diffuse = a_color + vec4( Diffuse, 1.0 );
//	v_Light = vec4( L, 1.0 );

//	v_color = vec4( u_materialEmission + Ambient + Specular, 1.0 );
//	v_diffuse = a_color * vec4( Diffuse, 1.0 );
//
//	v_color = vec4( u_materialEmission + Ambient + Specular/* + Rim*/, 1.0 );

//	v_vertex_color = a_color;
//	v_color = vec4( u_materialEmission + Ambient + Specular, 1.0 );
//	v_diffuse = vec4( Diffuse, 1.0 );
//	v_Light = vec4( L, 1.0 );
	
	v_color = a_color * vec4( u_materialEmission + Ambient + Diffuse + Specular, 1.0 );
	
	v_vertex = a_vertex;
	v_normal = a_normal;
	v_vcolor = a_color;
	v_texCoord = a_texCoord;
	
	v_Ambient = Ambient;
	v_Diffuse = Diffuse;
	v_Specular = Specular;
	
	v_Eye.x = dot(E, T);
	v_Eye.y = dot(E, B);
	v_Eye.z = dot(E, N);
	v_Eye = normalize(v_Eye);
	
	v_Light.x = dot(L, T);
	v_Light.y = dot(L, B);
	v_Light.z = dot(L, N);
	v_Light = normalize(v_Light);
#endif

	lowp vec3 E = normalize( u_eyePosition - a_vertex.xyz );
	lowp vec3 L = normalize( -u_lightPosition );

	lowp vec3 N = normalize( a_normal );
	lowp vec3 T = a_tangent;
	lowp vec3 B = cross( N, T );
	
//	v_vertex = a_vertex;
//	v_normal = a_normal;
	v_color = a_color + vec4( u_materialEmission, 1.0 );
	v_texCoord = a_texCoord;

	lowp float attenuation = 1.0 / u_lightConstantAttenuation;
	attenuation = 1.0;
	
	v_Ambient = u_materialAmbient * u_lightAmbient;
	v_Diffuse = u_materialDiffuse * u_lightDiffuse * attenuation;
	v_Specular = u_materialSpecular * u_lightSpecular * attenuation;

	v_Eye.x = dot(E, T);
	v_Eye.y = dot(E, B);
	v_Eye.z = dot(E, N);
//	v_Eye = normalize(v_Eye);

	v_Light.x = dot(L, T);
	v_Light.y = dot(L, B);
	v_Light.z = dot(L, N);
//	v_Light = normalize(v_Light);

	gl_Position = u_ModelViewProj * a_vertex;
}
