attribute highp vec4 a_vertex;
attribute lowp vec4 a_color;
attribute mediump vec2 a_texCoord;

uniform highp mat4 u_ModelViewProj;
uniform highp mat4 u_LightViewProj;

varying lowp vec4 v_color;
varying mediump vec2 v_texCoord;
varying mediump vec4 v_ShadowTexCoord;

const mat4 mT = mat4(
		0.5, 0.0, 0.0, 0.0,
		0.0, 0.5, 0.0, 0.0,
		0.0, 0.0, 1.0, 0.0,
		0.5, 0.5, 0.0, 1.0
	);

void main()
{
    gl_Position = u_ModelViewProj * a_vertex;
		
	//　シャドウマップ
//	highp vec4 pos = u_LightViewProj * a_vertex;	
//	v_ShadowTexCoord.s = ( pos.x / pos.w ) * 0.5 + 0.5;
//	v_ShadowTexCoord.t = ( pos.y / pos.w ) * 0.5 + 0.5;
//	v_ShadowTexCoord.s = ( (pos.x * 0.5) / pos.w ) + 0.5;
//	v_ShadowTexCoord.t = ( (pos.y * 0.5) / pos.w ) + 0.5;

	v_ShadowTexCoord = mT * u_LightViewProj * a_vertex;
		
	v_color = a_color;
	v_texCoord = a_texCoord;
}
