

uniform highp vec3 u_eyePosition;

uniform highp vec3 u_lightPosition;

uniform mediump float u_materialShininess;
uniform mediump vec4 u_color;


uniform lowp sampler2D u_texture;

varying highp vec4 v_vertex;
varying mediump vec3 v_normal;
varying lowp vec4 v_color;
varying mediump vec2 v_texCoord;

varying lowp vec3 v_ambient;
varying lowp vec3 v_diffuse;
varying lowp vec3 v_specular;

void main()
{	
	lowp vec3 N = normalize(v_normal);
		
	//　Diffuse Color
	lowp vec3 L = normalize(u_lightPosition - v_vertex.xyz);
							   
	mediump float diffuseLight = max(dot(L, N), 0.0);
	mediump vec3 diffuse = v_diffuse * diffuseLight;
	
	// Specular Color
	lowp vec3 V = normalize(u_eyePosition - v_vertex.xyz);
	lowp vec3 R = reflect( -V, N );	//　反射ベクトル -V + 2.0 * dot(N, V) * N;
	mediump float specularLight = pow(max(dot(L, R), 0.0), u_materialShininess);
	mediump vec3 specular = v_specular * specularLight;

	gl_FragColor = u_color * v_color * vec4(v_ambient + diffuse + specular, 1.0) * texture2D( u_texture, v_texCoord );
}
