attribute highp vec4 a_vertex;
attribute mediump vec3 a_normal;
attribute lowp vec4 a_color;
attribute mediump vec2 a_texCoord;

uniform highp mat4 u_ModelViewProj;
uniform lowp vec3 u_eyePosition;

uniform highp mat4 u_LightViewProj;
uniform highp mat4 u_LightViewProjBias;

uniform lowp vec3 u_lightAmbient;
uniform lowp vec3 u_lightDiffuse;
uniform lowp vec3 u_lightSpecular;
uniform highp vec3 u_lightPosition;
uniform mediump float u_lightConstantAttenuation;
uniform mediump float u_lightLinearAttenuation;
uniform mediump float u_lightQuadraticAttenuation;

uniform lowp vec3 u_materialAmbient;
uniform lowp vec3 u_materialDiffuse;
uniform lowp vec3 u_materialSpecular;
uniform mediump float u_materialShininess;

varying mediump vec3 v_normal;
varying lowp vec4 v_color;
varying mediump vec2 v_texCoord;
varying lowp vec4 v_diffuse;
varying lowp vec4 v_ambient;
varying highp vec4 v_ShadowTexCoord;
varying highp vec4 v_Depth;

void main()
{
    gl_Position = u_ModelViewProj * a_vertex;
	
	vec3 L = normalize( u_lightPosition - a_vertex.xyz );
	
	vec3 N = normalize( a_normal );
	
	//　色
//	v_diffuse = vec4(u_lightDiffuse,1.0) * max( dot( L, N ), 0.0 );
//	v_ambient = vec4(u_lightAmbient,1.0) * 0.3;
	
	
	v_diffuse = a_color * max( dot( L, N ), 0.0 );
	v_ambient = a_color * 0.3;
	
//	v_diffuse = vec4(1.0,1.0,1.0,1.0);
//	v_ambient = vec4(1.0,1.0,1.0,1.0);
	
	//　シャドウマップ
	v_ShadowTexCoord = u_LightViewProjBias * a_vertex;
	
	//　深度
	v_Depth = u_LightViewProj * a_vertex;
	
	v_normal = a_normal;
	v_color = a_color;
	v_texCoord = a_texCoord;
}
